<?php
$berogui_path = '/usr/local/www/berogui';
require("$berogui_path/includes/Helper/Helper.php");

##### INTERN FUNCTIONS #####
function cleanberoConf($bc) {
	foreach (['sbcvm-update-notif', 'has-major-issue', 'sbcvm-has-update', 'sbcvm-rebooting', 'sbcvm-update-completed', 'sbcvm-update-nbrequest'] as $key) {
		$bc->delete('root', $key);
	}
}
function doCacheUpdate($bc, &$html = null, &$msg = null) {
	$retval = Helper::system(1, "/bin/bash /etc/cron.daily/sbcvm-check-update >/dev/null", $output, ['timeout' => 600]);
	if ($retval != false) {
		global $berogui_path;
		require_once("$berogui_path/modules/UpdateTool/UpdateTool.php");
		include_once("$berogui_path/includes/lang.php");
		$upd = new UpdateTool();
		$html = $upd->loadFormByTab(1);
		$msg = $bc->get('root', 'sbcvm-has-update') == 1 && $bc->get('root', 'sbcvm-update-shownotif') == 1 ? NEW_PACKAGE_AVAILABLE_MESSAGE_DIS : '';
		return(true);
	}
	return(false);
}
function doUpdate($reboot_required) {
	/* run in background and ajax request check the status */
	return(Helper::systemBackground(1, '/bin/bash', '/usr/local/beroNet/bin/sbcvm-update', [$reboot_required]));
}

##### FORCE UPDATE AFTER AUTO FAILED OR TO FIX A MAJOR ISSUE ######
if (isset($_POST['force-update']) && $_POST['force-update']) {
	require("$berogui_path/misc/database.php");
	$ba = new beroAri();

	require_once("$berogui_path/includes/lang.php");
	if (Helper::getActivateOption() != '0') {
		header('Content-type: application/json');
		die(Helper::jsonEncode(['error' => UPDATE_TOOL_SBCVM_UPDATE_FAILED_ACTIVATE_NOTIF]));
	}
	else if (Helper::getTotalCalls() != '0') {
		header('Content-type: application/json');
		die(Helper::jsonEncode(['error' => UPDATE_TOOL_SBCVM_UPDATE_FAILED_ACTCALLS_NOTIF]));
	}

	### file overwritten during update. should lead to a fail
	doUpdate(0);
}
else if (isset($_POST['check_update']) && $_POST['check_update']) {
	require_once('/usr/fallback/beroConf.php');
	$bc = new beroConf('root');

	require("$berogui_path/misc/database.php");
	$ba = new beroAri();

	require_once("$berogui_path/includes/lang.php");
	// update successful and completed
	if ($bc->get('root', 'sbcvm-update-completed') == 1) {
		cleanberoConf($bc);
		header('Content-type: application/json');
		die(Helper::jsonEncode(['current_package' => $bc->get('root', 'sbcvm-package-current'), 'success' => UPDATE_TOOL_SBCVM_SUCCESSFUL]));
	}
	// a reboot is required. we answer to update GUI
	else if ($bc->get('root', 'sbcvm-rebooting') == 1) {
		cleanberoConf($bc);
		header('Content-type: application/json');
		die(Helper::jsonEncode(['rebooting' => UPDATE_TOOL_SBCVM_REBOOTING]));
	}
	// more than 600 request == 600 seconds == 10min: an issue occurs
	else if ($bc->get('root', 'sbcvm-nbrequest') > 600) {
		$bc->delete('root', 'sbcvm-update-nbrequest');
		header('Content-type: application/json');
		die(Helper::jsonEncode(['error' => UPDATE_TOOL_SBCVM_UPDATE_FAILED]));
	}
	sleep(1);
	$bc->set('root', 'sbcvm-update-request', (int) $bc->get('root', 'sbcvm-update-request') + 1);
	die();
}
##### RELOAD APT CACHE ####
else if (isset($_POST['reload_aptcache']) && $_POST['reload_aptcache']) {
	require_once('/usr/fallback/beroConf.php');
	$bc = new beroConf('root');

	$msg = '';
	$html = '';
	header('Content-type: application/json');
	die(Helper::jsonEncode(['status' => doCacheUpdate($bc, $html, $msg), 'html' => $html, 'msg' => $msg]));
}

##### MANUAL UPDATE #####
/* [CHECKING GET] */
unset($_GET);

/* [CHECKING POST] */
unset($_POST);

/* [EXEC AJAX] */
require_once('/usr/fallback/beroConf.php');
$bc = new beroConf('root');

### file overwritte during update. should lead to a fail
doUpdate($bc->get('root', 'sbcvm-update-reboot') == 1 ? 1 : 0);
exit(0);
?>
